:: Licensed Materials - Property of IBM
:: Rational ClearCase
:: (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
:: US Government Users Restricted Rights
:: Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
@echo off

setLocal EnableDelayedExpansion

:: Accept overrides from the values provided at install time
::  allows any rcleartool.bat to run any rcleartool version based 
::  on local environment variable overrides.
if not defined _JAVACMD set _JAVACMD=_JAVA_CMD_PATH_
if not defined RCLEARTOOL_HOME set RCLEARTOOL_HOME=_CCRC_CLI_PATH_
if not defined JARS_DIR set JARS_DIR=_TEAM_API_PATH_
if not defined CCRC_CLEARDIFF_PATH set CCRC_CLEARDIFF_PATH=_CCRC_CLEARDIFF_PATH_
if not defined ORG_APACHE_XML_PATH set ORG_APACHE_XML_PATH=_ORG_APACHE_XML_PATH_

:: Store the actual path to rcleartool
set PATH_TO_RCLEARTOOL=%~dp0

:: If after this, RCLEARTOOL_HOME is still the default CCRC_CLI_PATH
::  this means, user didn't override and eclipse hasn't configured this file
:: Use 0,15 so that this string does not get replaced by Launcher
set _r1=%RCLEARTOOL_HOME:~0,14%
set _r2=_CCRC_CLI_PATH
if "%_r1%"=="%_r2%" (
    call :executeLauncher
    set RCLEARTOOL_HOME=
    set JARS_DIR=
    exit /B %ERRORLEVEL%
)

:: Pull in rcleartool.conf options for the java command
set INI_PATH=%PATH_TO_RCLEARTOOL%rcleartool.conf
set INI_OPTIONS=
if exist "%INI_PATH%" (
    for /f "usebackq eol= tokens=* delims=" %%x in ("%INI_PATH%") do call :processIni %%x
)

:: Execute the java command with arguments
"%_JAVACMD%" %INI_OPTIONS% -Djava.util.logging.config.file="%PATH_TO_RCLEARTOOL%/logging.properties" -cp "%JARS_DIR%\stpwvcm.jar";"%JARS_DIR%\stpcmmn.jar";"%JARS_DIR%\stpcc.jar";"%JARS_DIR%\remote_core.jar";"%JARS_DIR%\commons-httpclient-3.0.jar";"%JARS_DIR%\commons-codec-1.3.jar";"%RCLEARTOOL_HOME%\commons-cli-1.1.jar";"%JARS_DIR%\icu4j-4_8.jar";"%RCLEARTOOL_HOME%";"%ORG_APACHE_XML_PATH%"%CUSTOM_CLASSPATH% com.ibm.rational.ccrc.cli.RCleartool %*
exit /B %ERRORLEVEL%

:processIni
set INI_OPTIONS=%INI_OPTIONS% %*
goto :EOF

:executeLauncher
echo Attempting to setup rcleartool for first use. Just a moment...
:: check if this is ctexplorer or eclipse.exe
if exist "%PATH_TO_RCLEARTOOL%startup.jar" (
    echo Invoking startup.jar
    start /D"%PATH_TO_RCLEARTOOL%" /B "Configure rcleartool.bat" "%_JAVACMD%" -cp "%PATH_TO_RCLEARTOOL%startup.jar" org.eclipse.core.launcher.Main -application com.ibm.rational.ccrc.cli.CliConfigureApplication
) 
if not exist "%PATH_TO_RCLEARTOOL%startup.jar" (
    set _found_file=false
    set PATH_TO_LAUNCHER=
    :: must go looking for org.eclipse.equinox.launcher*.jar
    echo Starting search for launcher
    for /R "%PATH_TO_RCLEARTOOL%" %%f in (*.jar) do call :fileSearch "%%f"
)
if "%_found_file%"=="false" (
    :: This time go two level up to look for org.eclipse.equinox.launcher*.jar
    for /R "%PATH_TO_RCLEARTOOL%\..\.." %%f in (*.jar) do call :fileSearch "%%f"
)
goto :EOF

:returnFromSearch
echo Return From Search, executing path to launcher %1
start /D"%PATH_TO_RCLEARTOOL%" /B "Configure rcleartool.bat" "%_JAVACMD%" -cp %1 org.eclipse.equinox.launcher.Main -application com.ibm.rational.ccrc.cli.CliConfigureApplication 
echo RCleartool now configured for use. Please re-enter command.
goto :EOF

:fileSearch
set _prefix=%~nx1
set _prefix=%_prefix:~0,28%
set _checkForNL1=%~nx1
set _checkForNL1=%_checkForNL1:~28,4%
set _suffix=%~nx1
set _suffix=%_suffix:~-4%
set PATH_TO_LAUNCHER=
if "%_prefix%"=="org.eclipse.equinox.launcher" (
    if "%_suffix%"==".jar" (
        if not "%_checkForNL1%"==".nl1" (
            echo FOUND %1
            if "%_found_file%"=="false" (
                set _found_file=true
                set PATH_TO_LAUNCHER=%1
                call :returnFromSearch %1
            )
        )
    )
)
goto :EOF
